//+------------------------------------------------------------------+
//|                                Profit Generator - Daily Bars.mq4 |
//|                       No Copyright, created in 2006, Open Source |
//|                                         http://www.forex-tsd.com |
//| See    http://www.forex-tsd.com/15990-post61.html                | 
//|        Freely receive, Freely give. Please post updated version. |
//+------------------------------------------------------------------+
#property copyright "Created in 2006, Open Source Project"
#property link      "http://www.forex-tsd.com"

extern int ID; // Change this number if running more than one EA 
extern double lots=1.0;
extern bool MM = false; //Use Money Management or not
extern int Risk = 10; //percent of available margin to risk.

extern int stoploss=20,takeprofit=30;

extern bool UseTrail=false;
extern int TrailingStop=0; 
extern int MaxTrades=1;          //maximum number of trades open at a time
extern bool UseHourTrade = False;
extern int  FromHourTrade = 8;
extern int  ToHourTrade = 18;
extern int LongBar=10; // sets the minimum length of the bar
extern bool UseLastPeriodPerams=false;// uses the high and low from last period for calculation
extern int period=240; // leave this number as zero to use the period from the chart.
extern bool OneTradeperPeriod=false;  //This will only allow one new trade per period.
extern bool DisablePeriodMGMT=false;
extern int LookBackMinutes=240; //Number of minuts to lookback
int bar;//tracks the period where a trade was placed.  Allows only one trade placed per period.
int LookBack; //Number of bars to lookback to calculate the highs, lows etc.


void deinit() 
{
   Comment("");
}

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && ID==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}

int start(){
   if(UseTrail)Trailing();
   if(orderscnt()==0){
      if (UseHourTrade){
         if(!(Hour()>=FromHourTrade&&Hour()<=ToHourTrade)){
            Comment("Non-Trading Hours!");
            return(0);
         }
      }
   }
   if(orderscnt()<MaxTrades){
      if(MM==true) lots = LotSize();
      if(!DisablePeriodMGMT){
         //if (Period() < 30) {Comment("change to M30 or higher pls"); return(0); }
         //if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);
      }
      CheckOpen();
   }   
}
int P(){
   if(period==0){
      return(Period()); 
   }else{
      return(period);
   }
}
   
void CheckOpen()
{ 
// ID=gb();  
   double tp,sl;
   double Hi, Lo, Op, Oo;
   bool y=OneTradeperPeriod; //added 3-25-2006
   
   if(UseLastPeriodPerams){
      int x=1;
   }else{
      x=0;
   }
   
   LookBack = MathCeil(LookBackMinutes/Period());   
   Hi = iHigh(NULL, 0, Highest(NULL,0,MODE_HIGH,LookBack,x));
   Lo = iLow(NULL, 0, Lowest(NULL,0, MODE_LOW,LookBack,x));
   Op = iOpen(NULL, 0, LookBack);

//   Hi = iHigh(NULL, P(), x); 
//   Lo = iLow(NULL, P(), x);  
//   Op = iOpen(NULL, P(), x);

   
//   Print(Hi, ",", Lo); // This shows how the value of hi and lo changes during the day

   if ((Hi-Lo)>LongBar*Point && Op<(Hi+Lo)/2 && Ask < Op && ( bar!=Bars || !y) )
   {
      if(stoploss==0){sl=0;}else{sl=Ask-stoploss*Point;}
      if(takeprofit==0){tp=0;}else{tp=Ask+takeprofit*Point;}
      OrderSend(Symbol(),OP_BUY,lots,Ask,2,sl,tp,"Profit Generator",ID,0,Blue);
      bar=Bars; 
   }
   if ((Hi-Lo)>LongBar*Point && Op>(Hi+Lo)/2 && Bid > Op && (bar!=Bars || !y) )
   {
      if(stoploss==0){sl=0;}else{sl=Bid+stoploss*Point;}
      if(takeprofit==0){tp=0;}else{tp=Bid-takeprofit*Point;}
      OrderSend(Symbol(),OP_SELL,lots,Bid,2,sl,tp,"Profit Generator",ID,0,Red); 
      bar=Bars;
   }
}
double LotSize(){
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 10000) / 10;
   if (lotMM < 0.1) lotMM = lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
} 


void Trailing(){
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS) && OrderMagicNumber()==ID && Symbol()==OrderSymbol() ){
         if(OrderType()==OP_BUY){
            if(TrailingStop>0){
               if(Bid-OrderOpenPrice()>Point*TrailingStop){
                  if(OrderStopLoss()<Bid-Point*TrailingStop){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                  }
               }
            }
         }else{
            if(TrailingStop>0){
               if(OrderOpenPrice()-Ask>Point*TrailingStop){
                  if(OrderStopLoss()>Ask+Point*TrailingStop){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
}